#pragma once

#include <SDL2/SDL_events.h> // Para SDL_Event
#include <SDL2/SDL_rect.h>	 // Para SDL_Rect
#include <SDL2/SDL_render.h> // Para SDL_Renderer, SDL_Texture
#include <SDL2/SDL_stdinc.h> // Para Uint32
#include <string>			 // Para string, basic_string
#include "player.h"			 // Para playerSpawn_t
#include "scoreboard.h"		 // Para board_t
class Asset;
class Cheevos;
class Debug;
class Input;
class ItemTracker;
class Resource;
class Room;
class RoomTracker;
class Screen;
class Stats;
class Text;
struct JA_Music_t;
struct JA_Sound_t;
struct Options;
struct SectionState;

class Game
{
private:
	// Objetos y punteros
	Screen *screen_;				 // Objeto encargado de manejar el renderizador
	SDL_Renderer *renderer_;		 // El renderizador de la ventana
	Room *room_;					 // Objeto encargado de gestionar cada habitación del juego
	Player *player_;				 // Objeto con el jugador
	ItemTracker *item_tracker_;		 // Lleva el control de los objetos recogidos
	RoomTracker *room_tracker_;		 // Lleva el control de las habitaciones visitadas
	Asset *asset_;					 // Objeto con la ruta a todos los ficheros de recursos
	Input *input_;					 // Objeto pata gestionar la entrada
	Text *text_;					 // Objeto para los textos del juego
	Scoreboard *scoreboard_;		 // Objeto encargado de gestionar el marcador
	Cheevos *cheevos_;				 // Objeto encargado de gestionar los logros del juego
	Resource *resource_;			 // Objeto con los recursos
	Debug *debug_;					 // Objeto para gestionar la información de debug
	Stats *stats_;					 // Objeto encargado de gestionar las estadísticas
	SDL_Texture *room_name_texture_; // Textura para escribir el nombre de la habitación

	// Variables
	JA_Music_t *music_;			// Musica que suena durante el juego
	Uint32 ticks_;				// Contador de ticks para ajustar la velocidad del programa
	Uint32 ticks_speed_;		// Velocidad a la que se repiten los bucles del programa
	std::string current_room_;	// Fichero de la habitación actual
	playerSpawn_t spawn_point_; // Lugar de la habitación donde aparece el jugador
	JA_Sound_t *death_sound_;	// Sonido a reproducir cuando muere el jugador
	board_t board_;				// Estructura con los datos del marcador
	bool paused_;				// Indica si el juego se encuentra en pausa
	bool black_screen_;			// Indica si la pantalla está en negro. Se utiliza para la muerte del jugador
	int black_screen_counter_;	// Contador para temporizar la pantalla en negro
	int total_items_;			// Cantidad total de items que hay en el mapeado del juego
	SDL_Rect room_name_rect_;	// Rectangulo donde pintar la textura con el nombre de la habitación

	// Actualiza el juego, las variables, comprueba la entrada, etc.
	void update();

	// Pinta los objetos en pantalla
	void render();

	// Comprueba los eventos de la cola
	void checkEvents();

#ifdef DEBUG
	// Pone la información de debug en pantalla
	void updateDebugInfo();

	// Pone la información de debug en pantalla
	void renderDebugInfo();
#endif

	// Escribe el nombre de la pantalla
	void renderRoomName();

	// Cambia de habitación
	bool changeRoom(std::string file);

	// Comprueba el teclado
	void checkInput();

	// Comprueba si el jugador esta en el borde de la pantalla y actua
	void checkPlayerOnBorder();

	// Comprueba las colisiones del jugador con los enemigos
	bool checkPlayerAndEnemies();

	// Comprueba las colisiones del jugador con los objetos
	void checkPlayerAndItems();

	// Comprueba si el jugador esta vivo
	void checkIfPlayerIsAlive();

	// Comprueba si ha terminado la partida
	void checkGameOver();

	// Mata al jugador
	void killPlayer();

	// Recarga todas las texturas
	void reLoadTextures();

	// Establece la pantalla en negro
	void setBlackScreen();

	// Actualiza las variables relativas a la pantalla en negro
	void updateBlackScreen();

	// Dibuja la pantalla negra
	void renderBlackScreen();

	// Pone el color del marcador en función del color del borde de la habitación
	void setScoreBoardColor();

	// Comprueba si ha finalizado el juego
	bool checkEndGame();

	// Obtiene la cantidad total de items que hay en el mapeado del juego
	int getTotalItems();

	// Va a la habitación designada
	void goToRoom(int border);

	// Pone el juego en pausa
	void switchPause();

	// Da vidas al jugador cuando está en la Jail
	void checkRestoringJail();

	// Inicializa el diccionario de las estadísticas
	void initStats();

	// Pone el nombre de la habitación en la textura
	void fillRoomNameTexture();

	// Comprueba algunos logros
	void checkSomeCheevos();

	// Comprueba los logros de completar el juego
	void checkEndGameCheevos();

public:
	// Constructor
	Game();

	// Destructor
	~Game();

	// Bucle para el juego
	void run();
};